from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Int, Boolean, File

Anvi_Get_Sequences_For_Gene_Calls_V0_1_0 = CommandToolBuilder(tool="anvi_get_sequences_for_gene_calls", base_command=["anvi-get-sequences-for-gene-calls"], inputs=[ToolInput(tag="in_contigs_db", input_type=String(optional=True), prefix="--contigs-db", doc=InputDocumentation(doc="Anvi'o contigs database generated by 'anvi-gen-\ncontigs-database' (default: None)")), ToolInput(tag="in_gene_caller_ids", input_type=String(optional=True), prefix="--gene-caller-ids", doc=InputDocumentation(doc="Gene caller ids. Multiple of them can be declared\nseparated by a delimiter (the default is a comma). In\nanvi-gen-variability-profile, if you declare nothing\nyou will get all genes matching your other filtering\ncriteria. In other programs, you may get everything,\nnothing, or an error. It really depends on the\nsituation. Fortunately, mistakes are cheap, so it's\nworth a try. (default: None)")), ToolInput(tag="in_flank_length", input_type=Int(optional=True), prefix="--flank-length", doc=InputDocumentation(doc="Extend sequences for gene calls with additional\nnucleotides from both ends. If the seqeunce for a\ntarget gene is between nucleotide positions START and\nSTOP, using a flank lenght of M will give you a\nsequence that starts at START - M and ends at STOP +\nM. (default: 0)")), ToolInput(tag="in_delimiter", input_type=String(optional=True), prefix="--delimiter", doc=InputDocumentation(doc="The delimiter to parse multiple input terms. The\ndefault is ','.")), ToolInput(tag="in_report_extended_def_lines", input_type=Boolean(optional=True), prefix="--report-extended-deflines", doc=InputDocumentation(doc="When declared, the deflines in the resulting FASTA\nfile will contain more information. (default: False)")), ToolInput(tag="in_wrap", input_type=File(optional=True), prefix="--wrap", doc=InputDocumentation(doc="When to wrap sequences when storing them in a FASTA\nfile. The default is '120'. A value of '0' would be\nequivalent to 'do not wrap'.")), ToolInput(tag="in_export_gff_three", input_type=File(optional=True), prefix="--export-gff3", doc=InputDocumentation(doc="If this is true, the output file will be in GFF3\nformat. (default: False)")), ToolInput(tag="in_get_aa_sequences", input_type=Boolean(optional=True), prefix="--get-aa-sequences", doc=InputDocumentation(doc="Store amino acid sequences instead. (default: False)")), ToolInput(tag="in_external_gene_calls", input_type=File(optional=True), prefix="--external-gene-calls", doc=InputDocumentation(doc="An optional external gene calls file path that\nprecisely describes the set of gene sequences\nexported. Using this file you can create an anvi'o\ncontigs database from the resulting genes FASTA file\nwithout having to do a gene calling from scratch.\n(default: None)")), ToolInput(tag="in_genomes_storage", input_type=File(optional=True), prefix="--genomes-storage", doc=InputDocumentation(doc="Anvi'o genomes storage file (default: None)")), ToolInput(tag="in_genome_names", input_type=File(optional=True), prefix="--genome-names", doc=InputDocumentation(doc="Genome names to 'focus'. You can use this parameter to\nlimit the genomes included in your analysis. You can\nprovide these names as a comma-separated list of\nnames, or you can put them in a file, where you have a\nsingle genome name in each line, and provide the file\npath. (default: None)")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="--output-file", doc=InputDocumentation(doc="File path to store results. (default: None)"))], outputs=[ToolOutput(tag="out_export_gff_three", output_type=File(optional=True), selector=InputSelector(input_to_select="in_export_gff_three", type_hint=File()), doc=OutputDocumentation(doc="If this is true, the output file will be in GFF3\nformat. (default: False)")), ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="File path to store results. (default: None)"))], container="quay.io/biocontainers/anvio-minimal:7--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Anvi_Get_Sequences_For_Gene_Calls_V0_1_0().translate("wdl")

